﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head><title>Context Types of Elasticsearch Controls</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Context Types of Elasticsearch Controls</h1>
        <p>There are two main types of Elasticsearch controls available in Saviynt Identity Governance and Administration (IGA). The detailed description are provided in the following sections:</p>
        <h3 id="ContextTypesofElasticsearchControls-Usercontextbasedelasticsearchcontrols">User context based elasticsearch controls</h3>
        <p>USER context based controls are implemented to achieve user based visibility of control data. When creating controls based on user context, IGA looks for the user name aliased as USER CONTEXT as a column in result set. If&#160;a user logs into IGA, they will be able to view only the violations across their username in the run history. Users having access to ROLE_ADMIN and ROLE_READONLY are considered as exceptional to this visibility constraint and can view violations of all the available users in the application.</p>
        <p>Sample query&#160;</p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select distinct excv.attributevalue as&#160;'AWS Account', a.name as&#160;'IAM User',u.Firstname as&#160;'First Name', u.lastname as&#160;'Last Name', u.email as&#160;'Email Address', a.Created_on as&#160;'Creation Time',a.LastLogondate as&#160;'Last Login'  &#160;, u.userkey as&#160;'USERCONTEXT'  &#160;from accounts a INNER JOIN users u on u.username=a.name and u.customproperty1 IN ('T','R','D') INNER JOIN endpoints ep On ep.endpointkey = a.endpointkey INNER Join entitlement_types et ON et.endpointkey = ep.endpointkey INNER JOIN securitysystems sc ON et.systemkey = sc.systemkey INNER JOIN externalconnection exc on sc.externalconnection = exc.externalconnectionkey INNER JOIN externalconnectiontype exct on exc.externalconnectiontype = exct.externalconnectiontypekey and exct.connectiontype =&#160;'AWS'  &#160;INNER JOIN externalconnattvalue excv on excv.connectiontype = exc.externalconnectionkey and excv.attributekey =&#160;'AWS_ACCOUNT_ID'  &#160;where a.name not like&#160;'xyz'  </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <h3 id="ContextTypesofElasticsearchControls-InverseUsercontextbasedelasticsearchcontrols">Inverse User context based elasticsearch controls</h3>
        <p>INVERSE USER context based controls are implemented to restrict users to take actions (Provisioning and Deprovisioning) on their own record in the Analytics History report and allows to take actions, if enabled, on other items that does not belong to him. When creating controls based on inverse user context, IGA looks for the USER CONTEXT as a column in a result set. When this context is set, any rows that have the user's name will not be displayed while those that do not have user's name will be displayed.</p>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">Users having access to ROLE_ADMIN and ROLE_READONLY are considered as exceptional to this visibility constraint and can view violations of all the available users in the application.</p>
        </div>
        <p><strong>Sample query</strong>
        </p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">Select userkey as USERCONTEXT, username, firstname from userlimit 10</MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p>To restrict a user to take action on his own record, perform the following steps:</p>
        <ol>
            <li>
                <p>While creating an Elastic Search based Analytics control, navigate to <strong>Context </strong>drop down and select <strong>Inverse User</strong>. <br /><img src="../Resources/Images/create new analytics config.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;width: 693px;height: 535px;" /><br /></p>
            </li>
        </ol>
        <ol MadCap:continue="true">
            <li>
                <p>Click <strong>Create</strong>.</p>
            </li>
            <li>
                <p>Navigate to <strong>Analytics Configuration List</strong> page and click <strong>Run Now</strong> to run the control.<br />The control fetches all the 10 users as mentioned in the above sample query. </p>
            </li>
            <li>
                <p>Navigate to the Run History page and check the Run History List section.<br />You can see the record of remaining 9 users. <br /><img src="../Resources/Images/inverse user context.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;width: 616px;height: 447px;" /><br /></p>
            </li>
        </ol>
        <h3 id="ContextTypesofElasticsearchControls-Organizationcontextbasedelasticsearchcontrols">Organization context based elasticsearch controls</h3>
        <p>ORGANIZATION context based controls are implemented to achieve organization based visibility of control data. When creating controls based on organization context, IGA looks for the organization name aliased as ORGANIZATION CONTEXT as a column in result set.&#160;</p>
        <ol>
            <li>
                <p>ORGANIZATION CONTEXT based controls are achieved by</p>
                <ul>
                    <li>
                        <p>Grouping Endpoints under Organization</p>
                    </li>
                    <li>
                        <p>Adding organization to a SAV role having access by the user</p>
                    </li>
                </ul>
            </li>
            <li>
                <p>If a user having access to the SAV role logs in, he will be able to view the results of all the controls belonging to associated endpoints within an organization which are in turn&#160; associated to a SAV role.</p>
            </li>
        </ol>
        <p><strong>Sample query</strong>
        </p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select distinct excv.attributevalue as&#160;'AWS Account',ep.endpointname as endpointname, ev.entitlement_value as&#160;'ARN',ev.ENTITLEMENTID as&#160;'Key ID', IFNULL(customproperty13,&#160;'') as&#160;'Alias',ev.customproperty9 as&#160;'Region',If(ev.customproperty10='false','No','Yes') as&#160;'Key Rotated',ev.customproperty2 as&#160;'Creation Time',ce.CUSTOMERKEY as ORGANIZATIONCONTEXT from entitlement_values ev INNER JOIN entitlement_types et ON ev.entitlementtypekey = et.entitlementtypekey And et.Entitlementname =&#160;'Encryptionkeys'  &#160;and ev.customproperty10='false'  &#160;INNER JOIN securitysystems sc ON et.systemkey = sc.systemkey inner join endpoints ep on ep.SECURITYSYSTEMKEY = sc.systemkey inner join customer_endpoint ce on ce.endpoints = ep.endpointkey INNER JOIN externalconnection exc ON sc.externalconnection = exc.externalconnectionkey INNER JOIN externalconnectiontype exct ON exc.externalconnectiontype = exct.externalconnectiontypekey and exct.connectiontype =&#160;'AWS'  &#160;INNER JOIN externalconnattvalue excv ON excv.connectiontype = exc.externalconnectionkey and excv.attributekey =&#160;'AWS_ACCOUNT_ID'  &#160;and ev.status =&#160;1   </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p>&#160;</p>
    </body>
</html>